// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// ManagedIdentity is an autogenerated mock type for the ManagedIdentity type
type ManagedIdentity struct {
	mock.Mock
}

// AssignManagedIdentityToWorkspace provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) AssignManagedIdentityToWorkspace(ctx context.Context, input *types.AssignManagedIdentityInput) (*types.Workspace, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Workspace
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.AssignManagedIdentityInput) (*types.Workspace, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.AssignManagedIdentityInput) *types.Workspace); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Workspace)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.AssignManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateManagedIdentity provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) CreateManagedIdentity(ctx context.Context, input *types.CreateManagedIdentityInput) (*types.ManagedIdentity, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentity
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityInput) (*types.ManagedIdentity, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityInput) *types.ManagedIdentity); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentity)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateManagedIdentityAccessRule provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) CreateManagedIdentityAccessRule(ctx context.Context, input *types.CreateManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentityAccessRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityAccessRuleInput) *types.ManagedIdentityAccessRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentityAccessRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateManagedIdentityAccessRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateManagedIdentityAlias provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) CreateManagedIdentityAlias(ctx context.Context, input *types.CreateManagedIdentityAliasInput) (*types.ManagedIdentity, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentity
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityAliasInput) (*types.ManagedIdentity, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityAliasInput) *types.ManagedIdentity); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentity)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateManagedIdentityAliasInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateManagedIdentityCredentials provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) CreateManagedIdentityCredentials(ctx context.Context, input *types.CreateManagedIdentityCredentialsInput) ([]byte, error) {
	ret := _m.Called(ctx, input)

	var r0 []byte
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityCredentialsInput) ([]byte, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateManagedIdentityCredentialsInput) []byte); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]byte)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateManagedIdentityCredentialsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteManagedIdentity provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) DeleteManagedIdentity(ctx context.Context, input *types.DeleteManagedIdentityInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteManagedIdentityInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteManagedIdentityAccessRule provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) DeleteManagedIdentityAccessRule(ctx context.Context, input *types.DeleteManagedIdentityAccessRuleInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteManagedIdentityAccessRuleInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteManagedIdentityAlias provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) DeleteManagedIdentityAlias(ctx context.Context, input *types.DeleteManagedIdentityAliasInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteManagedIdentityAliasInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetManagedIdentity provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) GetManagedIdentity(ctx context.Context, input *types.GetManagedIdentityInput) (*types.ManagedIdentity, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentity
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityInput) (*types.ManagedIdentity, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityInput) *types.ManagedIdentity); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentity)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetManagedIdentityAccessRule provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) GetManagedIdentityAccessRule(ctx context.Context, input *types.GetManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentityAccessRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityAccessRuleInput) *types.ManagedIdentityAccessRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentityAccessRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetManagedIdentityAccessRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetManagedIdentityAccessRules provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) GetManagedIdentityAccessRules(ctx context.Context, input *types.GetManagedIdentityInput) ([]types.ManagedIdentityAccessRule, error) {
	ret := _m.Called(ctx, input)

	var r0 []types.ManagedIdentityAccessRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityInput) ([]types.ManagedIdentityAccessRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetManagedIdentityInput) []types.ManagedIdentityAccessRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.ManagedIdentityAccessRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UnassignManagedIdentityFromWorkspace provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) UnassignManagedIdentityFromWorkspace(ctx context.Context, input *types.AssignManagedIdentityInput) (*types.Workspace, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Workspace
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.AssignManagedIdentityInput) (*types.Workspace, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.AssignManagedIdentityInput) *types.Workspace); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Workspace)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.AssignManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateManagedIdentity provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) UpdateManagedIdentity(ctx context.Context, input *types.UpdateManagedIdentityInput) (*types.ManagedIdentity, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentity
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateManagedIdentityInput) (*types.ManagedIdentity, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateManagedIdentityInput) *types.ManagedIdentity); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentity)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateManagedIdentityInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateManagedIdentityAccessRule provides a mock function with given fields: ctx, input
func (_m *ManagedIdentity) UpdateManagedIdentityAccessRule(ctx context.Context, input *types.UpdateManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ManagedIdentityAccessRule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateManagedIdentityAccessRuleInput) (*types.ManagedIdentityAccessRule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateManagedIdentityAccessRuleInput) *types.ManagedIdentityAccessRule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ManagedIdentityAccessRule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateManagedIdentityAccessRuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewManagedIdentity interface {
	mock.TestingT
	Cleanup(func())
}

// NewManagedIdentity creates a new instance of ManagedIdentity. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewManagedIdentity(t mockConstructorTestingTNewManagedIdentity) *ManagedIdentity {
	mock := &ManagedIdentity{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
